// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//
//-------------------------------------------------------------------

// AvalVideoLineSensorDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "AvalVideoLineSensor.h"
#include "AvalVideoLineSensorDlg.h"
#include "LicenceDlg.h"
#include "ConfFileDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define TIMER_ID_GRAB 1		


/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAvalVideoLineSensorDlg _CAO

CAvalVideoLineSensorDlg::CAvalVideoLineSensorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAvalVideoLineSensorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAvalVideoLineSensorDlg)
	m_asope = FALSE;
	m_sizex = 0;
	m_sizey = 0;
	m_offsetx = 0;
	m_offsety = 0;
	m_bpp = -1;
	m_timeout = 0;
	m_cck = -1;
	m_sck = -1;
	m_scanrate = 0;
	m_chksampling = FALSE;
	m_mode = -1;
	m_start = -1;
	m_sampling = -1;
	m_reverse = FALSE;
	m_cmp1 = 0;
	m_cmp2 = 0;
	m_blnVideoOpened = false;
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

}

void CAvalVideoLineSensorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAvalVideoLineSensorDlg)
	DDX_Control(pDX, IDC_SPCMP2, m_spcmp2);
	DDX_Control(pDX, IDC_SPCMP1, m_spcmp1);
	DDX_Control(pDX, IDC_SPSCANRATE, m_spscanrate);
	DDX_Control(pDX, IDC_SPOFFSETY, m_spoffsety);
	DDX_Control(pDX, IDC_SPOFFSETX, m_spoffsetx);
	DDX_Control(pDX, IDC_SPTIMEOUT, m_sptimeout);
	DDX_Control(pDX, IDC_SPSIZEY, m_spsizey);
	DDX_Control(pDX, IDC_SPSIZEX, m_spsizex);
	DDX_Control(pDX, IDC_TIME, m_time);
	DDX_Check(pDX, IDC_ASCOPE, m_asope);
	DDX_Text(pDX, IDC_SIZEX, m_sizex);
	DDX_Text(pDX, IDC_SIZEY, m_sizey);
	DDX_Text(pDX, IDC_OFFSETX, m_offsetx);
	DDX_Text(pDX, IDC_OFFSETY, m_offsety);
	DDX_CBIndex(pDX, IDC_BPP, m_bpp);
	DDX_Text(pDX, IDC_TIMEOUT, m_timeout);
	DDX_CBIndex(pDX, IDC_CCK, m_cck);
	DDX_CBIndex(pDX, IDC_SCK, m_sck);
	DDX_Text(pDX, IDC_SCANRATE, m_scanrate);
	DDX_Check(pDX, IDC_CHKSAMPLING, m_chksampling);
	DDX_CBIndex(pDX, IDC_MODE, m_mode);
	DDX_CBIndex(pDX, IDC_START, m_start);
	DDX_CBIndex(pDX, IDC_SAMPLING, m_sampling);
	DDX_Check(pDX, IDC_REVERSE, m_reverse);
	DDX_Text(pDX, IDC_CMP1, m_cmp1);
	DDX_Text(pDX, IDC_CMP2, m_cmp2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAvalVideoLineSensorDlg, CDialog)
	//{{AFX_MSG_MAP(CAvalVideoLineSensorDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_ASCOPE, OnAscope)
	ON_BN_CLICKED(IDC_DISP1, OnDisp1)
	ON_BN_CLICKED(IDC_DISPFULL, OnDispfull)
	ON_BN_CLICKED(IDC_GRAB, OnGrab)
	ON_BN_CLICKED(IDC_DISPMINUS, OnDispminus)
	ON_BN_CLICKED(IDC_DISPPLUS, OnDispplus)
	ON_BN_CLICKED(IDC_INITIALIZE, OnInitialize)
	ON_BN_CLICKED(IDC_SAVEIMAGE, OnSaveimage)
	ON_BN_CLICKED(IDC_FREERUN, OnFreerun)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAvalVideoLineSensorDlg bZ[W nh

BOOL CAvalVideoLineSensorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	/* -------------------------------------------------------------------------------- */
	// FvxSample 
	CLicenceDlg dlg;
	CConfFileDlg fdlg;

	// CZXʂ̕\
	if (dlg.DoModal() == IDOK){

		//Ӂ
		// ߂COM̏sƂYȂłB
		CoInitialize(NULL);
		CWnd *pwnd ;
		IUnknown *p_unknown;
		long err_no = 0;

		// _CAOɓ\tĂFvxDisplayEx̃CX^X擾AX}[g|C^Ɋt܂B
		pwnd = GetDlgItem(IDC_FVXDISPLAYEX1);		// FvxDisplayEx̃nh擾
		p_unknown = pwnd->GetControlUnknown();		// Rg[̎IUnknownC^[tFCX擾
		p_unknown->QueryInterface(__uuidof(IFvxDisplayEx2Ptr),(void**)&m_FvxDisplayEx);

		// eFvxRg[̃CX^X𐶐܂B
		// w肷NXԈႦȂ悤ӂĂB
		m_FvxFileAccess.CreateInstance( __uuidof( FvxFileAccess ) ); 
		m_FvxImage.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxVideo_Aval.CreateInstance( __uuidof( FvxVideo_Aval ) ); 
		m_FvxPerformanceCounter.CreateInstance( __uuidof( FvxPerformanceCounter ) ); 

		// J荞ݖ
		GetDlgItem(IDC_GRAB)->EnableWindow(FALSE);
		GetDlgItem(IDC_FREERUN)->EnableWindow(FALSE);
		// rfIfoCX̏ԂL
		m_blnVideoOpened = false;

		// fBXvC̏
		m_FvxDisplayEx->CreateDisplay(1,0);

		// rfIݒt@C̑I
		fdlg.DoModal();

		// R{{bNXɃACeǉ--------
		CComboBox*    pcmb;
		// Mode
		pcmb = ( CComboBox* )GetDlgItem( IDC_MODE );
		pcmb->AddString( "Normal" );
		pcmb->AddString( "Trigger" );
		pcmb->AddString( "EncoderScan" );
		pcmb->AddString( "EncoderLine" );
		// CCK
		pcmb = ( CComboBox* )GetDlgItem( IDC_CCK );
		pcmb->AddString( "5MHz" );
		pcmb->AddString( "10MHz" );
		pcmb->AddString( "20MHz" );
		pcmb->AddString( "40MHz" );
		// SCK
		pcmb = ( CComboBox* )GetDlgItem( IDC_SCK );
		pcmb->AddString( "5MHz" );
		pcmb->AddString( "10MHz" );
		pcmb->AddString( "20MHz" );
		pcmb->AddString( "40MHz" );
		// Bpp
		pcmb = ( CComboBox* )GetDlgItem( IDC_BPP );
		pcmb->AddString( "8bpp" );
		pcmb->AddString( "10bpp" );
		pcmb->AddString( "12bpp" );
		pcmb->AddString( "14bpp" );
		// Sampling
		pcmb = ( CComboBox* )GetDlgItem( IDC_SAMPLING );
		pcmb->AddString( "x2" );
		pcmb->AddString( "x4" );
		// Start
		pcmb = ( CComboBox* )GetDlgItem( IDC_START );
		pcmb->AddString( "CPU" );
		pcmb->AddString( "Trigger" );
		pcmb->AddString( "Z" );

		// Xs{^͈̔͐ݒ
		m_spsizex.SetRange(0,9999);
		m_spsizey.SetRange(0,9999);
		m_spoffsetx.SetRange(0,9999);
		m_spoffsety.SetRange(0,9999);
		m_spscanrate.SetRange(0,9999);
		m_spcmp1.SetRange(0,9999);
		m_spcmp2.SetRange(0,9999);
		
		UpdateData(FALSE); 

		// rfIݒt@CR|[lgɐݒ
 		m_FvxVideo_Aval->PutVideoConfFile( _bstr_t( fdlg.m_conffile ) );

		// rfIfoCXI[v
		try {

			m_FvxVideo_Aval->OpenDevice();

		} catch( _com_error ) {
		
			m_FvxVideo_Aval->GetErrReport( &err_no );
			MessageBox("rfIfoCX̃I[vɎs܂" , "G[" , MB_ICONWARNING | MB_OK );
			MessageBox("\tgEFAI܂" , "G[" , MB_ICONWARNING | MB_OK );
			EndDialog( IDCANCEL );
			return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
		}

        // GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
        // 炩ChangeImageSize\bhɂImagẽTCYύXĂ
        // i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
		m_FvxVideo_Aval->ChangeImageSize(m_FvxImage);

		// p[^t@C̓eʂɕ\
		InitLoad(fdlg.m_conffile);

		// J荞ݗL
		GetDlgItem(IDC_GRAB)->EnableWindow(TRUE);
		GetDlgItem(IDC_FREERUN)->EnableWindow(TRUE);
		
		// rfIfoCX̏ԂL
		m_blnVideoOpened = true;

		// 摜̕\
		m_FvxDisplayEx->DrawImage(m_FvxImage);

	}else{

		// ӂĂ炦Ȃ瑦I
		EndDialog( IDCANCEL );
	}

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
	
}

void CAvalVideoLineSensorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CAvalVideoLineSensorDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CAvalVideoLineSensorDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CAvalVideoLineSensorDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if (IsIconic() == 0 ) {

		if ( m_FvxDisplayEx != NULL ){

			CWnd *pwnd;
			CRect rect;

			pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );
			pwnd->GetWindowRect( rect );

			// XN[WNCAgWɕϊ
			ScreenToClient( rect );

			// FvxDisplayEx̃TCYύX
			pwnd->MoveWindow( rect.left , rect.top, cx - (rect.left + 20) , cy - (rect.top + 20) , TRUE );
		}
	}
}

void CAvalVideoLineSensorDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
    // t[Ȃ΁A~B
    if ( m_intIsFreerun == 1 ) {
		KillTimer( TIMER_ID_GRAB );
		GetDlgItem(IDC_GRAB)->EnableWindow(TRUE);
		GetDlgItem(IDC_FREERUN)->SetWindowText("Freerun");
        m_intIsFreerun = 0;
	}
	// rfIfoCXI[vĂꍇ̓N[Y܂
    if ( m_blnVideoOpened ) {
		m_FvxVideo_Aval->CloseDevice();
	}
}

void CAvalVideoLineSensorDlg::OnAscope() 
{
	UpdateData(TRUE);
	if (m_asope) m_FvxDisplayEx->PutAScopeMode(DISPLAYEX_AScopeAuto);
	if (!m_asope) m_FvxDisplayEx->PutAScopeMode(DISPLAYEX_AScopeDisable);
}

// {\
void CAvalVideoLineSensorDlg::OnDisp1() 
{
    m_FvxDisplayEx->PutMagnification( 1 );
	GetDlgItem(IDC_DISPPLUS)->EnableWindow(TRUE);
	GetDlgItem(IDC_DISPMINUS)->EnableWindow(TRUE);
}

void CAvalVideoLineSensorDlg::OnDispfull() 
{

	CWnd *pwnd;
	CRect rect;
    pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );
	pwnd->GetWindowRect( rect );

    double dblScaleX = (double)(rect.right - rect.left) / m_FvxImage->GetImageWidth();
    double dblScaleY = (double)(rect.bottom - rect.top) / m_FvxImage->GetImageHeight();

    if ( dblScaleX < dblScaleY  ) {
        m_FvxDisplayEx->PutMagnification( dblScaleX );
	} else {
        m_FvxDisplayEx->PutMagnification( dblScaleY );
	}
			
	GetDlgItem(IDC_DISPPLUS)->EnableWindow(TRUE);
	GetDlgItem(IDC_DISPMINUS)->EnableWindow(TRUE);
}

void CAvalVideoLineSensorDlg::OnGrab() 
{
    
	GetDlgItem(IDC_GRAB)->EnableWindow(FALSE);
	GetDlgItem(IDC_FREERUN)->EnableWindow(FALSE);
	GetDlgItem(IDC_INITIALIZE)->EnableWindow(FALSE);

    // ԑJn
	m_FvxPerformanceCounter->StartCount();   

    try {
		// 捞
		m_FvxVideo_Aval->GrabSync( m_FvxImage );
	} catch( _com_error ) {
		CString szErr;
		long err_no = 0;
		m_FvxVideo_Aval->GetErrReport( &err_no );
		szErr.Format("捞G[( %d )",err_no);
		MessageBox(szErr, "G[" , MB_ICONWARNING | MB_OK );
	}
		
	// 荞񂾉摜ʂɕ\
	m_FvxDisplayEx->DrawImage( m_FvxImage );

	// ԑI
	double dblTime = 0;
	m_FvxPerformanceCounter->StopCount( &dblTime );
    
	GetDlgItem(IDC_GRAB)->EnableWindow(TRUE);
	GetDlgItem(IDC_FREERUN)->EnableWindow(TRUE);
	GetDlgItem(IDC_INITIALIZE)->EnableWindow(TRUE);
	CString szTmp;
	szTmp.Format("%.2fms",dblTime);
	m_time.SetWindowText(szTmp);
}

// \{minus
void CAvalVideoLineSensorDlg::OnDispminus() 
{
    m_FvxDisplayEx->PutMagnification( m_FvxDisplayEx->GetMagnification() - 0.1 );
    if ( m_FvxDisplayEx->GetMagnification() < 0.5 ) {
		GetDlgItem(IDC_DISPMINUS)->EnableWindow(FALSE);
	} else {
		GetDlgItem(IDC_DISPMINUS)->EnableWindow(TRUE);
	}
	GetDlgItem(IDC_DISPPLUS)->EnableWindow(TRUE);
}

// \{plus
void CAvalVideoLineSensorDlg::OnDispplus() 
{
    m_FvxDisplayEx->PutMagnification( m_FvxDisplayEx->GetMagnification() + 0.1 );
    if ( m_FvxDisplayEx->GetMagnification() > 4 ) {
		GetDlgItem(IDC_DISPPLUS)->EnableWindow(FALSE);
	} else {
		GetDlgItem(IDC_DISPPLUS)->EnableWindow(TRUE);
	}
	GetDlgItem(IDC_DISPMINUS)->EnableWindow(TRUE);
}

// ݒ̎s
void CAvalVideoLineSensorDlg::OnInitialize() 
{
	
    if (!UpdateData(TRUE)) return;
	
	if ( m_blnVideoOpened ) {
        // rfIfoCXI[vĂꍇ͈UN[Y܂
        m_FvxVideo_Aval->CloseDevice();
        m_blnVideoOpened = false;
	}
		
	// spX̎擾
	TCHAR path[_MAX_PATH+1];
	TCHAR drive[_MAX_DRIVE+1];
	TCHAR dir[_MAX_DIR+1];
	TCHAR filename [_MAX_DIR+1];

	::GetModuleFileName(GetModuleHandle(NULL), path, _MAX_PATH);
	_tsplitpath(path, drive, dir, filename, NULL);

	CString szTmp;
    szTmp = dir;
	szTmp = szTmp + "\\temp.ini";

	// xAtemp.ini ɏoāAēxI[v
    SaveParamTmpFile( szTmp );

	::Sleep(1000);
    
	// rfIݒt@CR|[lgɐݒ
	m_FvxVideo_Aval->PutVideoConfFile( _bstr_t( szTmp ) );

	// rfIfoCXI[v
	try {

		m_FvxVideo_Aval->OpenDevice();
		m_FvxVideo_Aval->ChangeImageSize( m_FvxImage );
		m_FvxDisplayEx->DrawImage( m_FvxImage );
	    m_blnVideoOpened = true;

	} catch( _com_error ) {
	
		long err_no = 0;
		m_FvxVideo_Aval->GetErrReport( &err_no );
		MessageBox("rfIfoCX̃I[vɎs܂" , "G[" , MB_ICONWARNING | MB_OK );
	}

}

// ݂̃p[^Ńp[^ݒt@C
void CAvalVideoLineSensorDlg::SaveParamTmpFile(CString szIni)
{

    long res = 0;
	CString szTmp;

    // Version
	szTmp.Format("%d",m_Version);
	res = ::WritePrivateProfileString("Version", "Version", szTmp, szIni);
    // Kind
	szTmp.Format("%d",m_Kind);
    res = ::WritePrivateProfileString("Device", "Kind", szTmp, szIni);
    // ID
	szTmp.Format("%d",m_ID);
    res = ::WritePrivateProfileString("Device", "ID", szTmp, szIni);
    // Num
	szTmp.Format("%d",m_Num);
    res = ::WritePrivateProfileString("Device", "Num", szTmp, szIni);
    // HorizontalSize
	szTmp.Format("%d",m_sizex);
    res = ::WritePrivateProfileString("Video", "HorizontalSize", szTmp, szIni);
    // VerticalSize
	szTmp.Format("%d",m_sizey);
    res = ::WritePrivateProfileString("Video", "VerticalSize", szTmp, szIni);
    // HorizontalOffset
	szTmp.Format("%d",m_offsetx);
    res = ::WritePrivateProfileString("Video", "HorizontalOffset", szTmp, szIni);
    // VerticalOffset
	szTmp.Format("%d",m_offsety);
    res = ::WritePrivateProfileString("Video", "VerticalOffset", szTmp, szIni);
    // VerticalTotalSize
	szTmp.Format("%d",m_sizey);
    res = ::WritePrivateProfileString("Video", "VerticalTotalSize", szTmp, szIni);

    // BitWidth
	switch ( m_bpp ) {
	case 0:
		szTmp = "8";	break;
	case 1:
		szTmp = "10";	break;
	case 2:
		szTmp = "12";	break;
	case 3:
		szTmp = "14";	break;
	}
    res = ::WritePrivateProfileString("Video", "BitWidth", szTmp, szIni);

    // Force8
    res = ::WritePrivateProfileString("Video", "Force8", "1", szIni);
    // Timeout
    szTmp.Format("%d",m_timeout );
	res = ::WritePrivateProfileString("Video", "Timeout", szTmp, szIni);
    // CCK
	switch ( m_cck ) {
	case 0:
		szTmp = "5";	break;
	case 1:
		szTmp = "10";	break;
	case 2:
		szTmp = "20";	break;
	case 3:
		szTmp = "40";	break;
	}
    res = ::WritePrivateProfileString("Trigger", "CCK", szTmp, szIni);
    // SCK
	switch ( m_sck ) {
	case 0:
		szTmp = "5";	break;
	case 1:
		szTmp = "10";	break;
	case 2:
		szTmp = "20";	break;
	case 3:
		szTmp = "40";	break;
	}
    res = ::WritePrivateProfileString("Trigger", "SCK", szTmp, szIni);

    // ScanRate
    szTmp.Format("%d",m_scanrate);
	res = ::WritePrivateProfileString("Trigger", "ScanRate", szTmp, szIni);
    // Sampling
	if (m_chksampling) szTmp = "0";
	else szTmp = "1";
    res = ::WritePrivateProfileString("Trigger", "Sampling", szTmp, szIni);
    // InputMode
    szTmp.Format("%d",m_mode);
	res = ::WritePrivateProfileString("Trigger", "InputMode", szTmp, szIni);
    // EncStart
    szTmp.Format("%d",m_start);
	res = ::WritePrivateProfileString("Encoder", "EncStart", szTmp, szIni);
    // EncSingle
	if ( m_sampling == 1) szTmp = "0";
	else  szTmp = "1";
    res = ::WritePrivateProfileString("Encoder", "EncSingle", szTmp, szIni);
    // EncPulse
	if ( m_reverse ) szTmp = "1";
	else szTmp = "0";
	res = ::WritePrivateProfileString("Encoder", "EncPulse", szTmp, szIni);
    // CompReg1
    szTmp.Format("%d",m_cmp1);
	res = ::WritePrivateProfileString("Encoder", "CompReg1", szTmp, szIni);
    // CompReg2
    szTmp.Format("%d",m_cmp2);
    res = ::WritePrivateProfileString("Encoder", "CompReg2", szTmp, szIni);
    // tbV
    res = ::WritePrivateProfileString(NULL, NULL, NULL, szIni);
}

void CAvalVideoLineSensorDlg::InitLoad(CString szIni)
{

    // Version
    m_Version = GetPrivateProfileInt("Version", "Version", 1, szIni);
    // Kind
    m_Kind = GetPrivateProfileInt("Device", "Kind", 14, szIni);
    // ID
    m_ID = GetPrivateProfileInt("Device", "ID", -1, szIni);
    // Num
    m_Num = GetPrivateProfileInt("Device", "Num", -1, szIni);
    // Mode
    m_mode = GetPrivateProfileInt("Trigger", "InputMode", 0, szIni);
    // SizeX
    m_sizex = GetPrivateProfileInt("Video", "HorizontalSize", 1024, szIni);
	// SizeY
    m_sizey = GetPrivateProfileInt("Video", "VerticalSize", 1024, szIni);
	// OffsetX
    m_offsetx = GetPrivateProfileInt("Video", "HorizontalOffset", 0, szIni);
    // OffsetY
    m_offsety = GetPrivateProfileInt("Video", "VerticalOffset", 0, szIni);
    // ScanRate
    m_scanrate = GetPrivateProfileInt("Trigger", "ScanRate", 300, szIni);
    // Timeout
    m_timeout = GetPrivateProfileInt("Video", "Timeout", 5000, szIni);
    
    // CameraClick
    long tmp = 0;
	tmp = GetPrivateProfileInt("Trigger", "CCK", 20, szIni);
	switch ( tmp ) {
	case 5:
		m_cck = 0;	break;
	case 10:
		m_cck = 1;	break;
	case 20:
		m_cck = 2;	break;
	case 40:
		m_cck = 3;	break;
	}

    // Sampling Click
    tmp = GetPrivateProfileInt("Trigger", "SCK", 20, szIni);
	switch ( tmp ) {
	case 5:
		m_sck = 0;	break;
	case 10:
		m_sck = 1;	break;
	case 20:
		m_sck = 2;	break;
	case 40:
		m_sck = 3;	break;
	}

    // BitWidth
    tmp = GetPrivateProfileInt("Video", "BitWidth", 8, szIni);
	switch ( tmp ) {
	case 8:
		m_bpp = 0;	break;
	case 10:
		m_bpp = 1;	break;
	case 12:
		m_bpp = 2;	break;
	case 14:
		m_bpp = 3;	break;
	}
    
    // Sampling
    tmp = GetPrivateProfileInt("Trigger", "Sampling", 1, szIni);
	switch ( tmp ) {
	case 0:
		m_chksampling = true;	break;
	case 1:
		m_chksampling = false;	break;
	}
    
    // Encorder Sampling
    tmp = GetPrivateProfileInt("Encoder", "EncSingle", 0, szIni);
	switch ( tmp ) {
	case 0:
		m_sampling = 1;	break;
	case 1:
		m_sampling = 0;	break;
	}
    // Encorder Start
    m_start = GetPrivateProfileInt("Encoder", "EncStart", 0, szIni);
    // Reverse
    tmp = GetPrivateProfileInt("Encoder", "EncPulse", 0, szIni);
	switch ( tmp ) {
	case 0:
		m_reverse = false;	break;
	case 1:
		m_reverse = true;	break;
	}

	// Comp1
    m_cmp1 = GetPrivateProfileInt("Encoder", "CompReg1", 0, szIni);
    // Comp2
    m_cmp2 = GetPrivateProfileInt("Encoder", "CompReg2", 4, szIni);

	UpdateData(FALSE);

}

void CAvalVideoLineSensorDlg::OnSaveimage() 
{
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		m_FvxFileAccess->PutFilePath ( _bstr_t( cFileDlg.GetPathName() ));

		try {
		
			m_FvxFileAccess->SaveBitmap( m_FvxImage );
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
	
}

// t[Jn/~
void CAvalVideoLineSensorDlg::OnFreerun() 
{

	if ( m_intIsFreerun == 1 ){
		GetDlgItem(IDC_GRAB)->EnableWindow(TRUE);
		GetDlgItem(IDC_INITIALIZE)->EnableWindow(TRUE);
		GetDlgItem(IDC_FREERUN)->SetWindowText("Freerun");
		KillTimer( TIMER_ID_GRAB );
		m_intIsFreerun = 0;
	} else {
		SetTimer( TIMER_ID_GRAB, 50, NULL );
		GetDlgItem(IDC_GRAB)->EnableWindow(FALSE);
		GetDlgItem(IDC_INITIALIZE)->EnableWindow(FALSE);
		GetDlgItem(IDC_FREERUN)->SetWindowText("Stop");
		m_intIsFreerun = 1;
	}
}

// t[
void CAvalVideoLineSensorDlg::OnTimer(UINT nIDEvent) 
{
	switch( nIDEvent ){
		case TIMER_ID_GRAB:

			if ( m_blnVideoOpened ) {

				try {
					// ԑJn
					m_FvxPerformanceCounter->StartCount();   
					// 捞
					m_FvxVideo_Aval->GrabASync( m_FvxImage );
					// ҂
					m_FvxVideo_Aval->GrabASyncStatus();
					// ԑI
					double dblTime = 0;
					m_FvxPerformanceCounter->StopCount( &dblTime );
					// 摜\
					m_FvxDisplayEx->DrawImage( m_FvxImage );
					CString szTmp;
					szTmp.Format("%.2fms",dblTime);
					m_time.SetWindowText(szTmp);
				} catch( _com_error ) {
					long err_no=0;
					CString szErr;
					m_FvxVideo_Aval->GetErrReport( &err_no );
					szErr.Format("捞G[( %d )",err_no);
					MessageBox(szErr, "G[" , MB_ICONWARNING | MB_OK );
					GetDlgItem(IDC_GRAB)->EnableWindow(TRUE);
					GetDlgItem(IDC_INITIALIZE)->EnableWindow(TRUE);
					GetDlgItem(IDC_FREERUN)->SetWindowText("Freerun");
					KillTimer( TIMER_ID_GRAB );
					m_intIsFreerun = 0;
					return;
				}
			}
	}
	
	CDialog::OnTimer(nIDEvent);
}
